# Setup elastic for wso2 log files and events

In this project we'll take a closer look to exporting the standard WSO2 Enterprise Integrator logs and events from a customer mediator, picking them up with filebeat and shipping them to logstash. logstash will extract the data and insert them nicely in elasticsearch. Finally there's kibana which will show us pretty visualizations of our data.

 ![Architecture](./img/architecture.jpeg) 


## Download and open up the Elastic VM
1) download the git repo from gitlab and checkout custom wso2 branch
    ```
    git clone <URL to this git repo>
    ```
2) navigate to the newly cloned git repo.
3) open a terminal of your chose and open the virtual machine. It's important to wait until the virtual machine has started completely!
    ```
    vagrant up
    ```
  
The installation of the Virtual Box Guest Additions may fail, because the kernel in the VM is an older version and the kernel source files can no longer be found. In that case, execute the following commands:
  
```sh
vagrant ssh
[vagrant@localhost ~]$ sudo yum update -y
[vagrant@localhost ~]$ exit
vagrant halt
vagrant up
```
  
  
## Once inside the virtual box
Here we can start our demo. The vagrant file already installed the wso2 docker container.

### Start up the elasticsearch, kibana, logstash and filebeat containers. 
Let's start by powering up the entire stack with docker-compose

1) Navigate to /vagrant/stack-docker
2) First we need to increase the default virtual memory
   ```
   sudo sysctl -w vm.max_map_count=262144
   ```
3) After that we need to run the setup script. This start up script is gonna create the keystore's for the elastic x-pack security module to work properly. We do this by running following command:
   ```
   docker-compose -f setup.yml up
   ```
   **IMPORTANT: at the end of the log output from previous command, a generated command is given. Save this password somewhere close, you'll need it later.**
4) Finally run the docker-compose command to start up the elastic stack:
   ```
   docker-compose up
   ```


### Log into wso2 carbon console and run the code to generate some logs.
To start up our piece of custom java code that logs the start and end of each sequence, we need to "test" the proxy.

1) Navigate to:
   ```
   https://localhost:9443/carbon
   ```
2) Login with admin:admin
3) Navigate to proxy-service list
4) Click on Try this service
   ![wso2 try service path](./img/wso2_try_service.PNG) 

### Log in to kibana and load in the dashboard export.
To easily view our data, we need to make a logstash index and configure some dashboards and visualizations

1) Use the saved password from the step above to log in into kibana, accessible at http://localhost:5601, username = elastic.
2) Click on the hamburger menu
   1) Scroll down
   2) Stack Management
   3) Saved Objects
3) On the right top side, click the import button and import the dashboard located here: **_/vagrant/kibana_export/wso2-saved-objects.ndjson_**

4) the standard logs contain the errors generated from the standard wso2 logs and the custom logs are generated by a wso2 mediator.
